| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Types | List of all members
SimpleProperty< TYPE, VERIFIER > Class Template Reference

SimpleProperty concrete class which implements the full Property interface. More...

`#include <GaudiKernel/Property.h>`

Inheritance diagram for SimpleProperty< TYPE, VERIFIER >:
[legend]
Collaboration diagram for SimpleProperty< TYPE, VERIFIER >:
[legend]

## Public Member Functions
| SimpleProperty (VERIFIER verifier=VERIFIER())
| "Almost default" constructor from verifier More...
| SimpleProperty (const TYPE &value, VERIFIER verifier=VERIFIER())
| The constructor from the value and verifier (ATLAS needs it!) More...
| SimpleProperty (std::string name, const TYPE &value, VERIFIER verifier=VERIFIER())
| The constructor from the name, value and verifier. More...
template<class OTHER >
| SimpleProperty (const PropertyWithValue< OTHER > &right)
| constructor from other property type More...
| SimpleProperty (const SimpleProperty &right)
| copy constructor (must be!) More...
| ~SimpleProperty () override=default
| virtual Destructor More...
SimpleProperty * | clone () const override
| implementation of Property::clone More...
SimpleProperty & | operator= (const TYPE &value)
| assignment form the value More...
template<class OTHER >
SimpleProperty & | operator= (const PropertyWithValue< OTHER > &right)
| assignment form the other property type More...
template<class OTHER >
SimpleProperty< TYPE, VERIFIER > & | operator= (const PropertyWithValue< OTHER > &right)
| assignment form the other property type More...
Public Member Functions inherited from PropertyWithVerifier< TYPE, VERIFIER >
VERIFIER & | verifier ()
const VERIFIER & | verifier () const
bool | set (const TYPE &value)
| update the value of the property/check the verifier More...
bool | setValue (const TYPE &value) override
| implementation of PropertyWithValue::setValue More...
template<class OTHER , class OTHERVERIFIER >
PropertyWithVerifier & | operator= (const PropertyWithVerifier< OTHER, OTHERVERIFIER > &right)
| templated assignment More...
template<class OTHER >
PropertyWithVerifier & | operator= (const PropertyWithValue< OTHER > &right)
| templated assignment More...
PropertyWithVerifier & | operator= (const TYPE &right)
| assignment More...
template<class OTHER >
PropertyWithVerifier< TYPE, VERIFIER > & | operator= (const PropertyWithValue< OTHER > &right)
| template assignment More...
template<class OTHER , class OTHERVERIFIER >
PropertyWithVerifier< TYPE, VERIFIER > & | operator= (const PropertyWithVerifier< OTHER, OTHERVERIFIER > &right)
| template assignment More...
Public Member Functions inherited from PropertyWithValue< TYPE >
| operator const TYPE & () const
| implicit conversion to the type More...
const TYPE & | value () const
| explicit conversion More...
bool | assign (const Property &source) override
| get the value from another property More...
bool | load (Property &dest) const override
| set value for another property More...
StatusCode | fromString (const std::string &s) override
| string -> value More...
std::string | toString () const override
| value -> string More...
void | toStream (std::ostream &out) const override
| value -> stream More...
template<class OTHER >
PropertyWithValue< TYPE > & | operator= (const PropertyWithValue< OTHER > &right)
Public Member Functions inherited from Property
const std::string & | name () const
| property name More...
const std::string & | documentation () const
| property documentation More...
const std::type_info * | type_info () const
| property type-info More...
std::string | type () const
| property type More...
const std::function< void(Property &)> & | readCallBack () const
| get a reference to the readCallBack More...
const std::function< void(Property &)> & | updateCallBack () const
| get a reference to the updateCallBack More...
virtual Property & | declareReadHandler (std::function< void(Property &)> fun)
| set new callback for reading More...
virtual Property & | declareUpdateHandler (std::function< void(Property &)> fun)
| set new callback for update More...
template<class HT >
Property & | declareReadHandler (void(HT::*MF)(Property &), HT *instance)
template<class HT >
Property & | declareUpdateHandler (void(HT::*MF)(Property &), HT *instance)
virtual void | useReadHandler () const
| use the call-back function at reading More...
virtual bool | useUpdateHandler ()
| use the call-back function at update More...
virtual | ~Property ()=default
| virtual destructor More...
void | setName (std::string value)
| set the new value for the property name More...
void | setDocumentation (std::string documentation)
| set the documentation string More...
virtual std::ostream & | fillStream (std::ostream &) const
| the printout of the property value More...

## Protected Types
typedef Gaudi::Utils::PropertyTypeTraits< TYPE > | Traits

## Additional Inherited Members
Public Types inherited from PropertyWithValue< TYPE >
typedef Gaudi::Utils::PropertyTypeTraits< TYPE > | Traits
| the type-traits for properties More...
typedef Traits::PVal | PVal
| the actual storage type More...
Protected Member Functions inherited from PropertyWithVerifier< TYPE, VERIFIER >
| PropertyWithVerifier (std::string name, typename Gaudi::Utils::PropertyTypeTraits< TYPE >::PVal value, const bool owner, const VERIFIER &verifier)
| the constructor with property name and value More...
| ~PropertyWithVerifier () override=default
| virtual destructor More...
Protected Member Functions inherited from PropertyWithValue< TYPE >
| PropertyWithValue (std::string name, PVal value, const bool owner)
| the constructor with property name and value More...
| PropertyWithValue (const PropertyWithValue &rhs)
| copy constructor (don't let the compiler generate a buggy one) More...
template<class OTHER >
| PropertyWithValue (const PropertyWithValue< OTHER > &right)
| copy constructor from any other type More...
| ~PropertyWithValue () override
| virtual destructor More...
PropertyWithValue & | operator= (const TYPE &value)
| assignment operator More...
PropertyWithValue & | operator= (const PropertyWithValue &rhs)
template<class OTHER >
PropertyWithValue & | operator= (const PropertyWithValue< OTHER > &right)
void | i_set (const TYPE &value)
| set the value More...
PVal | i_get () const
| get the value More...
Protected Member Functions inherited from Property
| Property (const std::type_info &type, std::string name="")
| constructor from the property name and the type More...
| Property (std::string name, const std::type_info &type)
| constructor from the property name and the type More...
| Property (const Property &)=default
| copy constructor More...
Property & | operator= (const Property &)=default
| assignment operator More...
Protected Attributes inherited from Property
std::function< void(Property &)> | m_readCallBack
std::function< void(Property &)> | m_updateCallBack

## Detailed Description

### template<class TYPE, class VERIFIER = BoundedVerifier<TYPE>>
class SimpleProperty< TYPE, VERIFIER >

SimpleProperty concrete class which implements the full Property interface.

Author
  Paul Maley
  CTDay
  Vanya BELYAEV ibely.nosp@m.aev@.nosp@m.physi.nosp@m.cs.s.nosp@m.yr.ed.nosp@m.u

Definition at line 13 of file HistoProperty.h.

## Member Typedef Documentation

template<class TYPE, class VERIFIER = BoundedVerifier<TYPE>>

typedef Gaudi::Utils::PropertyTypeTraits<TYPE> SimpleProperty< TYPE, VERIFIER >::Traits
| protected

Definition at line 495 of file Property.h.

## Constructor & Destructor Documentation

template<class TYPE , class VERIFIER>

SimpleProperty< TYPE, VERIFIER >::SimpleProperty | ( | VERIFIER | verifier = `VERIFIER()` | ) |

"Almost default" constructor from verifier

The constructor from verifier.

Definition at line 532 of file Property.h.

533 : PropertyWithVerifier<TYPE,VERIFIER>
534 ( "" , Traits::new_() , true , verifier )
535 {}
PropertyWithVerifier
Helper intermediate class which represent partly implemented property with value of concrete type and...
Definition: Property.h:382
PropertyWithVerifier::verifier
VERIFIER & verifier()
Definition: Property.h:401
template<class TYPE, class VERIFIER>

SimpleProperty< TYPE, VERIFIER >::SimpleProperty | ( | const TYPE & | value,
|  | VERIFIER | verifier = `VERIFIER()`
| ) |  |

The constructor from the value and verifier (ATLAS needs it!)

The constructor from the value and verifier.

Definition at line 541 of file Property.h.

543 : PropertyWithVerifier<TYPE,VERIFIER>
544 ( "" , Traits::new_(value) , true , verifier )
545 {}
PropertyWithVerifier
Helper intermediate class which represent partly implemented property with value of concrete type and...
Definition: Property.h:382
PropertyWithVerifier::verifier
VERIFIER & verifier()
Definition: Property.h:401
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
template<class TYPE, class VERIFIER>

SimpleProperty< TYPE, VERIFIER >::SimpleProperty | ( | std::string | name,
|  | const TYPE & | value,
|  | VERIFIER | verifier = `VERIFIER()`
| ) |  |

The constructor from the name, value and verifier.

Definition at line 551 of file Property.h.

554 : PropertyWithVerifier<TYPE,VERIFIER>
555 ( std::move(name) , Traits::new_(value) , true , verifier )
556 {}
PropertyWithVerifier
Helper intermediate class which represent partly implemented property with value of concrete type and...
Definition: Property.h:382
PropertyWithVerifier::verifier
VERIFIER & verifier()
Definition: Property.h:401
std::move
T move(T...args)
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
template<class TYPE , class VERIFIER >
template<class OTHER >

SimpleProperty< TYPE, VERIFIER >::SimpleProperty | ( | const PropertyWithValue< OTHER > & | right | ) |

constructor from other property type

Definition at line 563 of file Property.h.

564 : PropertyWithVerifier<TYPE,VERIFIER>
565 ( right.name() , Traits::new_( right.value() ) , true , VERIFIER() )
566 {}
Property::name
const std::string & name() const
property name
Definition: Property.h:45
PropertyWithVerifier
Helper intermediate class which represent partly implemented property with value of concrete type and...
Definition: Property.h:382
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
template<class TYPE, class VERIFIER>

SimpleProperty< TYPE, VERIFIER >::SimpleProperty | ( | const SimpleProperty< TYPE, VERIFIER > & | right | ) |

copy constructor (must be!)

Definition at line 572 of file Property.h.

573 : PropertyWithVerifier<TYPE,VERIFIER>
574 ( right.name() , Traits::new_( right.value() ) , true , right.verifier() )
575 {}
Property::name
const std::string & name() const
property name
Definition: Property.h:45
PropertyWithVerifier
Helper intermediate class which represent partly implemented property with value of concrete type and...
Definition: Property.h:382
PropertyWithVerifier::verifier
VERIFIER & verifier()
Definition: Property.h:401
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
template<class TYPE, class VERIFIER = BoundedVerifier<TYPE>>

SimpleProperty< TYPE, VERIFIER >::~SimpleProperty | ( |  | ) |
| override default

virtual Destructor

## Member Function Documentation

template<class TYPE , class VERIFIER >

SimpleProperty< TYPE, VERIFIER > * SimpleProperty< TYPE, VERIFIER >::clone | ( |  | ) | const
| inline override virtual

implementation of Property::clone

Implements Property.

Definition at line 582 of file Property.h.

583 { return new SimpleProperty(*this) ; }
SimpleProperty::SimpleProperty
SimpleProperty(VERIFIER verifier=VERIFIER())
"Almost default" constructor from verifier
Definition: Property.h:532
template<class TYPE, class VERIFIER >

SimpleProperty< TYPE, VERIFIER > & SimpleProperty< TYPE, VERIFIER >::operator= | ( | const TYPE & | value | ) |
| inline

assignment form the value

Definition at line 590 of file Property.h.

591 {
592 PropertyWithVerifier<TYPE,VERIFIER>::operator=( value );
593 return *this ;
594 }
PropertyWithVerifier::operator=
PropertyWithVerifier & operator=(const PropertyWithVerifier< OTHER, OTHERVERIFIER > &right)
templated assignment
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
template<class TYPE, class VERIFIER = BoundedVerifier<TYPE>>
template<class OTHER >

SimpleProperty& SimpleProperty< TYPE, VERIFIER >::operator= | ( | const PropertyWithValue< OTHER > & | right | ) |

assignment form the other property type

template<class TYPE, class VERIFIER = BoundedVerifier<TYPE>>
template<class OTHER >

SimpleProperty<TYPE,VERIFIER>& SimpleProperty< TYPE, VERIFIER >::operator= | ( | const PropertyWithValue< OTHER > & | right | ) |
| inline

assignment form the other property type

Definition at line 603 of file Property.h.

604 {
605 PropertyWithVerifier<TYPE,VERIFIER>::operator=( right );
606 return *this ;
607 }
PropertyWithVerifier::operator=
PropertyWithVerifier & operator=(const PropertyWithVerifier< OTHER, OTHERVERIFIER > &right)
templated assignment

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/HistoProperty.h
- GaudiKernel/GaudiKernel/Property.h